local metadata = {
"## Interface:FS15 1.2",
"## Title: TriggerExtend",
"## Notes: Setzt/Aendert Werte in Triggers",
"## Author: HappyLooser",
"## Version: 0.4",
"## Date: 02.02.2015",
"## Update: 18.03.2015",
"## Web: no",
"## Info: Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt"
}

TriggerExtend = {};
TriggerExtendMP = true;
TriggerExtendMPUpdate = false;
local pathSavegame;
local stationNames = "(TriggerExtend)sell station names: ";
local stationUpdateNames = "";
local start = true;
local Xml;
local delay = 3600000;
local updateDay = 0;
local wait = 0;
local changeType = "";
local timer = false;
TriggerExtendSellXml = "";

function TriggerExtendLoad()	
	print("---loading TriggerExtend v0.4 (by HappyLooser)---")	
	local path = getUserProfileAppPath();		
	local file = path.."/triggerExtendSettings.xml";		
	if g_server ~= nil and g_client ~= nil then		
		if fileExists(file) then
			print("loading "..file.." for TriggerExtend settings");		
			Xml = loadXMLFile("triggerExtendSettings_XML", file, "Trigger");
		else
			print("creating "..file.." for SellTriggerExtend settings");
			Xml = createXMLFile("triggerExtendSettings_XML", file, "Trigger");		
			setXMLString(Xml, "Trigger.SellTrigger.StationFreightYard", "silage:0.45,forage_mixing:0.8,deleteOld:false");				
		end;
		saveXMLFile(Xml);	
		Xml = loadXMLFile("triggerExtendSettings_XML", file, "Trigger");		
	end;	
end;

function getSellTypes(self, sellTypes)
	if sellTypes == nil or string.len(sellTypes) <= 2 then return false;end;
	local types = Utils.splitString(",", sellTypes);
	if types == nil then return false;end;
	local sellPrice = "";
	local sellType = "";
	local deleteOld = false;
	local pdaOn = "";
	local pdaOff = "";
	if string.find(sellTypes, "deleteOld:true") then deleteOld = true;end;
	for k,v in pairs(types) do
		if string.find(v, "deleteOld:") == nil and string.find(v, "pdaOn:") == nil and string.find(v, "pdaOff:") == nil then			
			if string.find(v, ":") == nil then				
				if string.len(sellType) >= 2 then sellType = sellType.. " ".. v;end;
				if string.len(sellPrice) >= 1 then sellPrice = sellPrice.. " 0.25";end;
				if string.len(sellType) == 0 then sellType = sellType.. v;end;
				if string.len(sellPrice) == 0 then sellPrice = sellPrice.. "0.25";end;
			else
				local typeAndPrice = Utils.splitString(":", v);
				if typeAndPrice ~= nil then
					if string.len(sellType) >= 2 then sellType = sellType.. " ".. typeAndPrice[1];end;
					if string.len(sellType) == 0 then sellType = sellType.. typeAndPrice[1];end;	
					if string.len(sellPrice) >= 1 then sellPrice = sellPrice.. " ".. typeAndPrice[2];end;
					if string.len(sellPrice) == 0 then sellPrice = sellPrice.. typeAndPrice[2];end;
				end;				
			end;			
		end;
		if string.find(v, "pdaOn:") then
			local replacePDA = string.gsub(v, "pdaOn:", "");
			replacePDA = string.gsub(replacePDA, " ", ",");
			pdaOn = replacePDA.. ",";			
		end;
		if string.find(v, "pdaOff:") then
			local replacePDA = string.gsub(v, "pdaOff:", "");
			replacePDA = string.gsub(replacePDA, " ", ",");
			pdaOff = replacePDA.. ",";			
		end;
	end;	
	return sellType, sellPrice, deleteOld, pdaOn, pdaOff
end;

function MilliSecondsToHours(sMilliSeconds)
	local nMilliSeconds = tonumber(sMilliSeconds)
	if nMilliSeconds == 0 then
	--return nil;
	return "00";
	else
	local nHours = string.format("%02.f", math.floor(nMilliSeconds/3600000));
	--local nMins = string.format("%02.f", math.floor(nMilliSeconds/60000 - (nHours*60000)));
	--local nSecs = string.format("%02.f", math.floor(nMilliSeconds/1000 - nHours*3600000 - nMins *60000));
	--local nMilliSecs = math.ceil(nMilliseconds - (nHours*3600000) - (nMins *60000) - (nSecs *1000))
	return nHours --..":"..nMins..":"..nSecs.."."--..nMilliSecs
	end
end

function table.val_to_str(v)
  if "string" == type(v) then
    v = string.gsub(v, "\n", "\\n");
    if string.match(string.gsub(v,"[^'\"]",""), '^"+$') then
      return "'" .. v .. "'";
    end;
    return '"' .. string.gsub(v,'"', '\\"') .. '"';
  else
    return "table" == type(v) and table.tostring(v) or tostring(v);
  end;
end;

function table.key_to_str(k)
  if "string" == type(k) and string.match(k, "^[_%a][_%a%d]*$") then
    return k;
  else
    return "[" .. table.val_to_str(k) .. "]";
  end;
end;

function table.tostring(tbl)
  local result, done = {}, {};
  for k,v in ipairs(tbl) do
    table.insert(result, table.val_to_str(v));
    done[k] = true;
  end;
  for k,v in pairs(tbl) do
    if not done[k] then
      table.insert(result, table.key_to_str(k) .. "=" .. table.val_to_str(v));
    end;
  end;
  return "{" .. table.concat( result, "," ) .. "}";
end

function TriggerExtend:loadMap(xmlFile)	
	local dir = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex);
	pathSavegame = dir;	
	TriggerExtendLoad();	
	if g_server ~= nil and g_client ~= nil then		
		synSellTriggers(true, false, nil);
	end;
	self.setExtendTrigger = TriggerExtendSellXml;
	self.loginEvent = false;
end;

function TriggerExtend:deleteMap()
	TriggerExtendMP = true;
	TriggerExtendMPUpdate = false;
	wait = 0;
	changeType = "";
	TriggerExtendSellXml = "";
	timer = false;	
end;

function TriggerExtend:mouseEvent(posX, posY, isDown, isUp, button)	
end;

function TriggerExtend:keyEvent(unicode, sym, modifier, isDown)	
end;

function TriggerExtend:updateTick(dt)				
end;

function TriggerExtend:update(dt)
	if g_server == nil and TriggerExtendMP then		
		TriggerExtendMP = false;
		TriggerExtendEvent.sendEvent(self.setExtendTrigger, true);
	end;
	if not timer then		
		timer = true;
		wait = MilliSecondsToHours(g_currentMission.environment.dayTime)*delay;
		updateDay = g_currentMission.environment.currentDay;
	end;		
	if timer and wait <= g_currentMission.environment.dayTime or updateDay ~= g_currentMission.environment.currentDay then 
		updateDay = g_currentMission.environment.currentDay		
		wait = MilliSecondsToHours(g_currentMission.environment.dayTime)*delay + delay;
		synSellTriggersHoursUpdate(true, false, nil);
	end;
end;

function TriggerExtend:draw(dt)
end;

function synSellTriggersHoursUpdate()	
	if string.len(changeType) >= 2 then		
		local changeTypeName = Utils.splitString(" ", changeType);
		for k,v in pairs(changeTypeName) do
			local typeAndPrice = Utils.splitString(":", v);
			local desc = Fillable.fillTypeNameToDesc[typeAndPrice[1]];
			if desc ~= nil then
				local oldHourPrice = Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice;
				if oldHourPrice == 0 then
					oldHourPrice = typeAndPrice[2];					
				end;
				local oldLiterPrice = Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter;				
				if oldLiterPrice == 0 then					
					Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter = oldHourPrice;					
				end;				
			end;
		end;		
	end	
end;

function synSellTriggers(isServer, isClient, sellTriggerNew)
	if start then
		print("Update TriggerExtend.......begin")		
		for k,tipTrigger in pairs(g_currentMission.tipTriggers) do			
			local stationName = getUserAttribute(tipTrigger.triggerId, "stationName");		
			local stationIdx = Utils.getNoNil(getUserAttribute(tipTrigger.triggerId, "stationIdx"), 1);	
			if stationName ~= nil then				
				local id = tipTrigger.triggerId;				
				local fillTypes = getUserAttribute(id, "fillTypes");
				local priceMultipliersString = getUserAttribute(id, "priceMultipliers");				
				if fillTypes == nil then
					fillTypes = getUserAttribute(id, "fruitTypes");
				end;
				if string.find(stationName, " ") then
					stationName = string.gsub(stationName, " ", "_");
				end;
				if isServer then					
					if priceMultipliersString ~= nil then						
						print(stationNames.. stationName.. "(".. fillTypes.. ")".. priceMultipliersString );						
					else						
						if fillTypes ~= nil then
							print(stationNames.. stationName.. "(".. fillTypes.. ") !!Warning!! Prices not found at station?");
						else
							print(stationNames.. stationName.. "(!!Warning!! FillTypes and prices not found at station?)");
						end;
					end;
				end;				
				if tipTrigger.priceMultipliers ~= nil or tipTrigger.acceptedFillTypes ~= nil then					
					local sellTypes = "";
					local sellPrices = 0;
					local deleteOldTypes = false;
					local pdaOn = "";
					local pdaOff = "";
					if isServer then
						if getXMLString(Xml, "Trigger.SellTrigger.".. stationName) ~= nil then
							TriggerExtendSellXml = TriggerExtendSellXml ..stationName .." " ..getXMLString(Xml, "Trigger.SellTrigger.".. stationName) ..";";						
							local foundSellTypes, foundSellPrices, foundDeleteOld, foundPDAOn, foundPDAOff = getSellTypes(tipTrigger, getXMLString(Xml, "Trigger.SellTrigger.".. stationName));
							if foundSellTypes ~= nil then
								sellTypes = foundSellTypes;
								sellPrices = foundSellPrices;
								deleteOldTypes = foundDeleteOld;
								pdaOn = foundPDAOn;
								pdaOff = foundPDAOff;
							end;						
						end;
					end;
					if isClient and sellTriggerNew ~= nil then					
						if string.find(sellTriggerNew, stationName .." ") ~= nil then
							local serverTriggers = Utils.splitString(";", sellTriggerNew);							
							for k,v in pairs(serverTriggers) do
								if string.find(v, stationName) ~= nil then
									serverTriggers = string.gsub(v, stationName.. " ", "")
									local languageStationName = g_i18n:getText(tipTrigger.stationName)
									stationUpdateNames = stationUpdateNames.. " ".. languageStationName;
									break;
								end;
							end;
							local foundSellTypes, foundSellPrices, foundDeleteOld, foundPDAOn, foundPDAOff = getSellTypes(tipTrigger, serverTriggers);
							if foundSellTypes ~= nil then
								sellTypes = foundSellTypes;
								sellPrices = foundSellPrices;
								deleteOldTypes = foundDeleteOld;
								pdaOn = foundPDAOn;
								pdaOff = foundPDAOff;
							end;						
						end;
					end;
					if deleteOldTypes then
						local types = Utils.splitString(" ", fillTypes);
						local multipliers = Utils.splitString(" ", priceMultipliersString);
						for k,v in pairs(types) do
							local desc = Fillable.fillTypeNameToDesc[v];
							if desc ~= nil then									
								tipTrigger.acceptedFillTypes[desc.index] = nil;
								tipTrigger.priceMultipliers[desc.index] = nil;
							end;
						end;
						if string.len(sellTypes) >= 2 then							
							fillTypes = sellTypes;
							if string.len(sellPrices) >= 2 and sellPrices ~= 0 then
								priceMultipliersString = sellPrices;
							end;
						end;
					else
						if string.len(sellTypes) >= 2 then							
							fillTypes = fillTypes.. " ".. sellTypes;
							if string.len(sellPrices) >= 2 and sellPrices ~= 0 then
								priceMultipliersString = priceMultipliersString.. " ".. sellPrices;
							end;
						end;
					end;											
					local types = Utils.splitString(" ", fillTypes);
					local multipliers = Utils.splitString(" ", priceMultipliersString);					
					sellTypes = sellTypes.. " ";
					for k,v in pairs(types) do
						local desc = Fillable.fillTypeNameToDesc[v];
						if desc ~= nil and string.find(sellTypes, v.. " ") ~= nil then														
							if tonumber(multipliers[k]) == 0 then
								tipTrigger.acceptedFillTypes[desc.index] = nil;
								tipTrigger.priceMultipliers[desc.index] = nil;
							else
								tipTrigger.acceptedFillTypes[desc.index] = true;							
								local pricePerLiter = Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter;
								if pricePerLiter == 0 or pricePerLiter == nil then								
									Fillable.fillTypeIndexToDesc[desc.index].pricePerLiter = tonumber(multipliers[k]);								
								end;							
								local previousHourPrice = Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice;
								if previousHourPrice == 0 or previousHourPrice == nil then								
									Fillable.fillTypeIndexToDesc[desc.index].previousHourPrice = tonumber(multipliers[k])
								end;							
								--if desc.nameI18N == nil then
								--	desc.nameI18N = v.. "*";
								--else
								--	desc.nameI18N = v.. "*";
								--end;							
								--local hudOverlay = desc.hudOverlayFilename;
								--if hudOverlay ~= nil then
								--	print("Fix Error Hud Fremd Mod")								
								--end;
								tipTrigger.priceMultipliers[desc.index] = tonumber(multipliers[k]);
								if tipTrigger.priceMultipliers[desc.index] == nil then
									tipTrigger.priceMultipliers[desc.index] = Utils.getNoNil(tipTrigger.defaultPriceMultiplier, 0);								
									if not tipTrigger.isFarmTrigger and tipTrigger.defaultPriceMultiplier == nil then
										print("Error: "..k.."th priceMultiplier is invalid in TipTrigger "..getName(id));
									end;
								else
									local fruitTypeDesc = FruitUtil.fruitTypes[v];
									if fruitTypeDesc == nil or FruitUtil.registerFruitType(v) == nil or  FruitUtil.registerFruitType(v) == false then
										if string.find(changeType, v.. ":") == nil then
											setChangeType(v, tonumber(multipliers[k])+0.0000000000111, false, false);									
										end;
									end;
								end;
							end;							
						end;						
					end;
					if string.len(pdaOn) >= 2 then
						local enable = Utils.splitString(",", pdaOn);
						for k,v in pairs(enable) do
							if string.len(v) >= 2 then
								local desc = Fillable.fillTypeNameToDesc[v];
								if desc ~= nil and not Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy then
									Fillable.addFillTypeToEconomy(Fillable.fillTypeNameToInt[v]);
								end;
							end;
						end;
					end;
					if string.len(pdaOff) >= 2 then
						local disable = Utils.splitString(",", pdaOff);
						for k,v in pairs(disable) do
							if string.len(v) >= 2 then
								local desc = Fillable.fillTypeNameToDesc[v];
								if desc ~= nil and Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy then
									Fillable.fillTypeIndexToDesc[desc.index].partOfEconomy = false;
								end;
							end;
						end;
					end;
				end;
			end;				
		end;		
		print("Update TriggerExtend.......end")
	end;	
end;

function setChangeType(fillType, price, oldPrice, newChange)
	if newChange then
		local tempChangeType = string.gsub(changeType, fillType.. ":".. oldPrice, "");
		changeType = tempChangeType;
	end;
	changeType = changeType.. fillType.. ":".. price.. " ";	
end;
addModEventListener(TriggerExtend);


TriggerExtendEvent = {};
TriggerExtendEvent_mt = Class(TriggerExtendEvent, Event);
InitEventClass(TriggerExtendEvent, "TriggerExtendEvent");

function TriggerExtendEvent:emptyNew()    
	local self = Event:new(TriggerExtendEvent_mt );
    self.className="TriggerExtendEvent";
    return self;
end;

function TriggerExtendEvent:new(sellTriggerNew, noEventSend)    	
	local self = TriggerExtendEvent:emptyNew();
	self.setExtendTrigger = sellTriggerNew;	
	self.loginEvent = noEventSend;	
    return self;
end;

function TriggerExtendEvent:readStream(streamId, connection)    
	self.setExtendTrigger = streamReadString(streamId);  
    self.loginEvent = streamReadBool(streamId);	
	self:run(connection);
end;

function TriggerExtendEvent:writeStream(streamId, connection)    	
	streamWriteString(streamId, self.setExtendTrigger);
	streamWriteBool(streamId, self.loginEvent); 
end;

function TriggerExtendEvent:run(connection)
	if self.setExtendTrigger ~= nil and not self.loginEvent and not TriggerExtendMPUpdate then		
		self.setExtendTrigger = self.setExtendTrigger;		
		self:setExtendTriggersEvent(self.setExtendTrigger, true);		
	end;
	if self.loginEvent and not TriggerExtendMPUpdate then		
		self.setExtendTrigger = TriggerExtendSellXml;
		TriggerExtendEvent.sendEvent(self.setExtendTrigger, false)	
	end;
end;

function TriggerExtendEvent.sendEvent(sellTriggerNew, noEventSend)		
	if g_server ~= nil and g_server ~= false and not noEventSend then		
		g_server:broadcastEvent(TriggerExtendEvent:new(sellTriggerNew, false), nil, nil, nil);		
	end;
	if g_server == nil and noEventSend then		
		g_client:getServerConnection():sendEvent(TriggerExtendEvent:new(sellTriggerNew, true));
	end;
end;


function TriggerExtendEvent:setExtendTriggersEvent(sellTriggerNew, noEventSend)	
	if sellTriggerNew ~= nil then		
		synSellTriggers(false, true, sellTriggerNew)
		TriggerExtendMPUpdate = true;
		g_currentMission.inGameMessage:showMessage("TriggerExtend", "update Sell Triggers:\n".. stationUpdateNames, 4000, false);				
	end;
end;

local function backupXMLFiles(self)
	print("backup savegame");
	local file = pathSavegame.."/triggerExtendSettings.xml";	
	if pathSavegame == nil then
		pathSavegame = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
	end;
	local path = getUserProfileAppPath();		
	local fileOld = pathSavegame.."/triggerExtendSettings.xml";
	copyFile(fileOld, file);
end;
--g_careerScreen.saveSavegame = Utils.prependedFunction(g_careerScreen.saveSavegame, backupXMLFiles);

local function getXMLBack(self)	
	print("test savegame");
	local file = pathSavegame.."/triggerExtendSettings.xml";	
	if pathSavegame == nil then
		pathSavegame = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
	end;
	local path = getUserProfileAppPath();		
	local fileOld = path.."/triggerExtendSettings.xml";
	--copyFile(fileOld, file);
end;

function copyFile1(_input, _output)
	io.input(_input)
	fileContent = io.read("*all")
	io.output(_output)
	io.write(fileContent)	
end;
--g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, getXMLBack);